#ifndef _RN171_H_
#define _RN171_H_

#include <system.h>

#pragma CLOCK_FREQ 8000000

extern unsigned char count = 3;			// global variable used to separate cosm command. 
extern unsigned char aux_flag = 0;	// global variable used in main function. 

volatile bit iofs@OSCCON.2;		      // OSCCON stable bit.
volatile bit tmr0if@INTCON.2;		    // TIMER0 overflow bit.
volatile bit tmr1if@PIR1.0;			 		// TIMER1 overflow bit.
volatile bit tmr0ie@INTCON.5;		    // TIMER0 enable overfolw bit.
volatile bit tmr0on@T0CON.7;			  // TIMER0 enable bit.
volatile bit tmr1on@T1CON.0;		 		// TIMER1 enable bit

volatile bit gie@INTCON.7;  		 		// General interrupt flag.
volatile bit peie@INTCON.6;  		 		// External interrupt flag.
volatile bit rcif@PIR1.5;        		// receive interrupt flag.

#define INTCON_CONF  11000000b   		// GIE/PIE enabled, TMR0 overflow disabled.
//#define INTCON3_CONF 10001000b   		// INT1IE, enabled.
#define RCON_CONF    00011100b   		// Interrupt priority disabled.
#define PIE1_CONF    00000001b			// enable TMR1 overflow.
#define TIME0_CONF   10000001b;   	// assigned to T0CON presc. 1/4, 16 bit, enabled.
#define TIMEFR_VAL   01100100b   		// value of 100d.= 20ms - 50Hz.
#define TIME1_CONF   10110001b   		// 16 bit,T1CON, 1/8 presc. Timer1 enabled.
#define TIME1_FIX    11111110b   		// to get the above times in ms. (8 bit).




void init();
char scan_analog(char);
void reset_array();
char get_result8bit();
short get_result();

void PW_LED_OnOff();                // in my case connected to PORTD,5.

#endif //_RN171_H_
