//////////////////////////////////////////////////////////////
// ADC interface code for PIC18F devices
//
// (c)Martin Hug 2012.
/////////////////////////////////////////////////////////////

#include "adc_ng.h"
#include "system.h"
#include <PIC18f4420.h>


unsigned char upper_lower[3];
unsigned short data_10bit[3];


unsigned char AN_IN;

unsigned char scan_analog(char analog_ch){

   AN_IN = analog_ch;
   unsigned short bitmerge; 	
   select_analog(AN_IN-1);    
 
       
        Go_Done = 1;
        while (Go_Done != 0);		

        upper_lower[0] = 0x00;                  // DEBUG test: Init byte = 0x00.
        upper_lower[1] = ad_h;
	      upper_lower[2] = ad_l;
				
				bitmerge = ad_l | ad_h << 8;
				data_10bit[AN_IN-1] = data_10bit[AN_IN-1] + bitmerge;
           
        if (AN_IN == 0)
        upper_lower[1] = upper_lower[1] | 0x00; // AN 0; 00'00b = 0 (RA0).
        if (AN_IN == 1)
        upper_lower[1] = upper_lower[1] | 0x04; // AN 1; 01'00b = 4 (RA1).
        if (AN_IN == 2)
        upper_lower[1] = upper_lower[1] | 0x08; // AN 2; 10'00b = 8 (RA2).
        if (AN_IN == 3) 
        upper_lower[1] = upper_lower[1] | 0x0C; // AN 3; 11'00b = 12 (RA3).
        if (AN_IN == 4) 
        upper_lower[1] = upper_lower[1] | 0x10; // AN 4; 100'00b = 16 (RA4).
        if (AN_IN == 5)
        upper_lower[1] = upper_lower[1] | 0x14; // AN 5; 101'00b = 20 (RA5).
      
        analog_ch--;
          if (!analog_ch){                  
          analog_ch = 0;
          }
       
     return analog_ch;
}
//
//

short get_result(){
		
    /*short Sum, ad_h_aux, ad_l_aux;
    ad_l_aux = ad_l;
    ad_h_aux = ad_h << 8;
    Sum = ad_h_aux | ad_l_aux;*/
    return data_10bit[AN_IN-1];
}

//
//

char get_result8bit(){
	  char upload = ad_l;																	// only 8 bit values.
    return upper_lower[2];
		}
//
//
unsigned char get_analog(char number){
    return upper_lower[number];
    }
//
//

void select_analog(char CH){

  switch (CH){
    case 0:
    adcon0 = 00000001b;                       // AN_0
    break;
    case 1: 
    adcon0 = 00000101b;                       // AN_1
    break;
    case 2:
    adcon0 = 00001001b;                       // AN_2
    break;
    case 3:
    adcon0 = 00001101b;                       // AN_3
    break;
    case 4:
    adcon0 = 00010001b;                       // AN_4
    break;
    case 5:
    adcon0 = 00010101b;                       // AN_5
    break;
  }
}
//
//
void reset_array(){
		char i = 3;
		while (i){
		data_10bit[i-1] = 0x00;
		i--;
		}
}
		






